Bug 130251 - curl includes library that changes ABI
curl includes library that changes ABI
Product: Fedora
Classification: Fedora
Component: curl (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jindrich Novy
Depends On:
  Show dependency treegraph
Reported: 2004-08-18 10:41 EDT by Sean Middleditch
Modified: 2013-07-02 19:01 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2007-10-24 18:04:59 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Provide curl-devel, Obsolete (versioned) curl-devel (612 bytes, patch)
2007-10-24 17:45 EDT, Ville Skyttä
no flags Details | Diff

  None (edit)
Description Sean Middleditch 2004-08-18 10:41:23 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7.2)
Gecko/20040809 Epiphany/1.2.7

Description of problem:
The curl package includes a library, libcurl, which other applications
will sometimes link against.  However, because this library is
packaged with the curl utility, there is no way to have two different
ABI incompatible versions of the libcurl library installed.  If a
third-party package requires libcurl.so.2, and the updated curl
utility needs and provides libcurl.so.3, I am forced to either not use
the third-party application or stay stuck with an older curl utility.

The libcurl library should be split into a separate package that
allows installation of different ABI-incompatible versions so that
software will Just Work(tm) without messing around with RPM-hell.

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1. install an app that requires an older libcurl.so.2
2. try to upgrade the curl utility

Additional info:
Comment 1 Daniel Stenberg 2004-10-03 18:37:16 EDT
I second this request whole-heartedly. My plea was posted and is
archived here:


AFAIK, Mandrake is the only current Linux distro that does this.
Comment 2 Steven Lawrance 2004-10-20 15:31:08 EDT
I also agree as yum update on Rawhide is broken for me due to
vorbis-tools, which has apparently not been recompiled yet against the
latest curl.

Here's my `yum update` output:

[root@catsmeow development]# yum update
Setting up Update Process
Setting up Repo:  development
repomd.xml                100% |=========================| 1.1 kB    00:00
Reading repository metadata in from local files
developmen: ################################################## 3430/3430
Excluding Packages
Excluding Incompatible Archs
Excluding Packages from Fedora Core 2.91 - Development Tree
Resolving Dependencies
Error: missing dep: libcurl.so.2 for pkg vorbis-tools
Comment 3 Steven Lawrance 2004-11-09 13:08:14 EST
Ahh, nevermind on Comment #2. Apparently, the RPM for vorbis-tools did
not obsolete the previous version, so after removing the version that
depended on the old curl with `rpm --erase vorbis-tools-1.0.1-2`, yum
update as-is works properly now. So, ignore comments 2 and 3 ;-).
Comment 4 Ville Skyttä 2007-10-24 17:45:45 EDT
Created attachment 236711 [details]
Provide curl-devel, Obsolete (versioned) curl-devel

Looks like libcurl has been split from curl in devel CVS, good.

However, libcurl-devel does not have Provides: curl-devel, requiring per-branch
adjustments for dependent packages, and has an unversioned Obsoletes on
curl-devel which is frowned upon and may cause "interesting" problems in the

The attached patch should fix both issues.
Comment 5 Jindrich Novy 2007-10-24 18:04:59 EDT
Ok, all should be fixed now.

Note You need to log in before you can comment on or make changes to this bug.